/* Pipez 0.1
 *
 * Copyright 2000 Jorn Baayen, jorn@nl.linux.org
 *
 * http://pipez.sourceforge.net
 *
 * This software is published under the GPL 
 */

#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "SDL.h"
#include "SDL_mixer.h"
#include "SDL_thread.h"
#include <unistd.h>


#define DATA_PREFIX "data/"

#define NUM_IMAGES 29
#define NUM_IMAGES2 7

void draw(int x, int y, int pict);

#define NUM_SOUNDS 1
const char *sound_names[NUM_SOUNDS] = {
  DATA_PREFIX "sounds/tick.wav"
};

const char *image_names[NUM_IMAGES] = {
  DATA_PREFIX "images/bron.bmp",
  DATA_PREFIX "images/recht_h.bmp",
  DATA_PREFIX "images/recht_v.bmp",
  DATA_PREFIX "images/rechtsboven.bmp",
  DATA_PREFIX "images/rechtsonder.bmp",
  DATA_PREFIX "images/kruis.bmp",
  DATA_PREFIX "images/linksonder.bmp",
  DATA_PREFIX "images/linksboven.bmp",
  DATA_PREFIX "images/next.bmp",
  DATA_PREFIX "images/time.bmp",
  DATA_PREFIX "images/fluid.bmp",
  DATA_PREFIX "images/stream.bmp",
  DATA_PREFIX "images/fill_h.bmp",
  DATA_PREFIX "images/fill_v.bmp",
  DATA_PREFIX "images/uh-uh.bmp",
  DATA_PREFIX "images/0.bmp",
  DATA_PREFIX "images/1.bmp",
  DATA_PREFIX "images/2.bmp",
  DATA_PREFIX "images/3.bmp",
  DATA_PREFIX "images/4.bmp",
  DATA_PREFIX "images/5.bmp",
  DATA_PREFIX "images/6.bmp",
  DATA_PREFIX "images/7.bmp",
  DATA_PREFIX "images/8.bmp",
  DATA_PREFIX "images/9.bmp",
  DATA_PREFIX "images/stream_pr.bmp",
  DATA_PREFIX "images/quitp.bmp",
  DATA_PREFIX "images/quitp_pr.bmp",
  DATA_PREFIX "images/gameover.bmp"
};

const char *image_names2[NUM_IMAGES2] = {
  DATA_PREFIX "images/sidebar.bmp",
  DATA_PREFIX "images/mainbackground.bmp",
  DATA_PREFIX "images/main.bmp",
  DATA_PREFIX "images/start.bmp",
  DATA_PREFIX "images/start_pr.bmp",
  DATA_PREFIX "images/quit.bmp",
  DATA_PREFIX "images/quit_pr.bmp"
};

SDL_Surface *images[NUM_IMAGES];
SDL_Surface *images2[NUM_IMAGES2];
SDL_Surface *screen;
SDL_Thread *thread;
SDL_Event event;
Mix_Music *music = NULL;
Mix_Chunk *sounds[NUM_SOUNDS];
Uint32 audio_rate = 22050;
Uint16 audio_format = AUDIO_S16;
Uint32 nu;
Uint32 tijd_nodig;
int audio_channels = 2;
int audio_buffers = 4096;
int sound;
int maparray[701][701];
int sidetile[7];
int sideposx[7];
int sideposy[7];
int fluidarrayx[500];
int fluidarrayy[500];
int fluidarraytype[500];
void erase(int x, int y, int w, int h, int bkgd);
void mainmenu();
void play();
void overstroom(int x, int y);
void nexttile(int x, int y, int lastx, int lasty);
void placetile(int nr);
int xrand, yrand;
int delay;
int punten;
int shouldwork = 1;
int tc = 0;
int Dtime = 1;
int finished = 0;

/* Play a sound: */

void playsound(int snd)
{
  if (sound)
    Mix_PlayChannel(-1, sounds[snd], 0);
}

/* ShowBMP -- display M$ Winblows BMP image */
int ShowBMP(char *file, SDL_Surface * screen, int x, int y)
{
  SDL_Surface *image;
  SDL_Rect dest;

  /* Load the BMP file into a surface */
  image = SDL_LoadBMP(file);
  if (image == NULL) {
    fprintf(stderr, "Couldn't load %s: %s\n", file, SDL_GetError());
    return -1;
  }

  /* Blit onto the screen surface.
     The surfaces should not be locked at this point.
   */
  dest.x = x;
  dest.y = y;
  dest.w = image->w;
  dest.h = image->h;
  SDL_BlitSurface(image, NULL, screen, &dest);

  /* Update the changed portion of the screen */
  SDL_UpdateRects(screen, 1, &dest);
  return 0;
}

void settile(int type, int x, int y)
{
  if ((maparray[x][y] != 0) && (maparray[x][y] != 8)
      && (maparray[x][y] != 9)) {
    maparray[x][y] = type;
    erase(x, y, 40, 40, 1);
    draw(x, y, type);

    sidetile[0] = sidetile[1];
    sidetile[1] = sidetile[2];
    sidetile[2] = sidetile[3];
    sidetile[3] = sidetile[4];
    sidetile[4] = sidetile[5];
    sidetile[5] = sidetile[6];
    sidetile[6] = ((rand() % 7) + 1);
    erase(sideposx[0], sideposy[0], 40, 40, 0);
    erase(sideposx[1], sideposy[1], 40, 40, 0);
    erase(sideposx[2], sideposy[2], 40, 40, 0);
    erase(sideposx[3], sideposy[3], 40, 40, 0);
    erase(sideposx[4], sideposy[4], 40, 40, 0);
    erase(sideposx[5], sideposy[5], 40, 40, 0);
    erase(sideposx[6], sideposy[6], 40, 40, 0);
    draw(sideposx[0], sideposy[0], sidetile[0]);
    draw(sideposx[1], sideposy[1], sidetile[1]);
    draw(sideposx[2], sideposy[2], sidetile[2]);
    draw(sideposx[3], sideposy[3], sidetile[3]);
    draw(sideposx[4], sideposy[4], sidetile[4]);
    draw(sideposx[5], sideposy[5], sidetile[5]);
    draw(sideposx[6], sideposy[6], sidetile[6]);
  }
  return;
}

int fluid(void *unused)
{
  finished = -1;
  draw((xrand + 11), (yrand + 30), 13);
  SDL_Delay(delay);
  draw((xrand + 11), (yrand + 32), 13);
  SDL_Delay(delay);
  draw((xrand + 11), (yrand + 34), 13);
  SDL_Delay(delay);
  draw((xrand + 11), (yrand + 36), 13);
  SDL_Delay(delay);
  draw((xrand + 11), (yrand + 38), 13);
  SDL_Delay(delay);
  draw((xrand + 11), (yrand + 40), 13);
  if (maparray[xrand][yrand + 40] == 2 || maparray[xrand][yrand + 40] == 3
      || maparray[xrand][yrand + 40] == 5
      || maparray[xrand][yrand + 40] == 7) {
    // Passend tile onder bron
    punten = 0;
    nexttile(xrand, (yrand + 40), xrand, yrand);
  } else {
    overstroom(xrand, yrand);
  }
  tc = 0;
  fprintf(stderr, "Thread quitting...\n");
  finished = 1;
  return 0;
}

void nexttile(int x, int y, int lastx, int lasty)
{
  int i;
  punten++;
  switch (maparray[x][y]) {
  case 1:
    maparray[x][y] = 8;
    if (lastx == (x - 40)) {
      for (i = x; i <= (x + 40); i += 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    } else {
      for (i = (x + 40); i >= x; i -= 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    }
    // Horizontaal
    if (
	(maparray[x + 40][y] == 1 || maparray[x + 40][y] == 6
	 || maparray[x + 40][y] == 7 || maparray[x + 40][y] == 5
	 || maparray[x + 40][y] == 9) && lastx == (x - 40)) {
      //Rechts
      nexttile((x + 40), y, x, y);
      break;
    }
    if (
	(maparray[x - 40][y] == 1 || maparray[x - 40][y] == 5
	 || maparray[x - 40][y] == 3 || maparray[x - 40][y] == 4
	 || maparray[x - 40][y] == 9) && lastx == (x + 40)) {
      nexttile((x - 40), y, x, y);
      break;
      //Links
    }
    overstroom(x, y);
    break;
  case 2:
    maparray[x][y] = 8;
    // Verticaal
    if (lasty == (y - 40)) {
      for (i = y; i <= (y + 40); i += 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    } else {
      for (i = (y + 40); i >= y; i -= 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    }
    if (
	(maparray[x][y + 40] == 2 || maparray[x][y + 40] == 3
	 || maparray[x][y + 40] == 7 || maparray[x][y + 40] == 5
	 || maparray[x][y + 40] == 9) && lasty == (y - 40)) {
      //Beneden
      nexttile(x, (y + 40), x, y);
      break;
    }
    if (
	(maparray[x][y - 40] == 2 || maparray[x][y - 40] == 5
	 || maparray[x][y - 40] == 6 || maparray[x][y - 40] == 4
	 || maparray[x][y - 40] == 9) && lasty == (y + 40)) {
      //Boven
      nexttile(x, (y - 40), x, y);
      break;
    }
    overstroom(x, y);
    break;
  case 3:
    maparray[x][y] = 8;
    // Rechtsboven
    if (lasty == (y - 40)) {
      for (i = y; i <= (y + 29); i += 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
      for (i = (x + 11); i <= (x + 40); i += 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    } else {
      for (i = (x + 40); i >= (x + 11); i -= 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
      for (i = (y + 26); i >= y; i -= 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    }
    if (
	(maparray[x][y - 40] == 2 || maparray[x][y - 40] == 6
	 || maparray[x][y - 40] == 4 || maparray[x][y - 40] == 5
	 || maparray[x][y - 40] == 9) && lastx == (x + 40)) {
      //Vanaf boven
      nexttile(x, (y - 40), x, y);
      break;
    }
    if (
	(maparray[x + 40][y] == 1 || maparray[x + 40][y] == 5
	 || maparray[x + 40][y] == 6 || maparray[x + 40][y] == 7
	 || maparray[x + 40][y] == 9) && lasty == (y - 40)) {
      //Vanaf rechts
      nexttile((x + 40), y, x, y);
      break;
    }
    overstroom(x, y);
    break;
  case 4:
    maparray[x][y] = 8;
    // Rechtsonder
    if (lasty == (y + 40)) {
      for (i = (y + 40); i >= (y + 26); i -= 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
      for (i = (x + 11); i <= (x + 40); i += 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    } else {
      for (i = (x + 40); i >= (x + 11); i -= 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
      for (i = (y + 11); i <= (y + 40); i += 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    }
    if (
	(maparray[x][y + 40] == 2 || maparray[x][y + 40] == 7
	 || maparray[x][y + 40] == 3 || maparray[x][y + 40] == 5
	 || maparray[x][y + 40] == 9) && lastx == (x + 40)) {
      //Vanaf onder
      nexttile(x, (y + 40), x, y);
      break;
    }
    if (
	(maparray[x + 40][y] == 1 || maparray[x + 40][y] == 5
	 || maparray[x + 40][y] == 6 || maparray[x + 40][y] == 7
	 || maparray[x + 40][y] == 9) && lasty == (y + 40)) {
      //Vanaf rechts
      nexttile((x + 40), y, x, y);
      break;
    }
    overstroom(x, y);
    break;
  case 9:
  case 5:
    maparray[x][y] = 9;
    // Kruis
    if (lastx == (x - 40) || lastx == (x + 40)) {
      if (lastx == (x - 40)) {
	for (i = x; i <= (x + 40); i += 2) {
	  draw(i, (y + 11), 12);
	  SDL_Delay(delay);
	}
      } else {
	for (i = (x + 40); i >= x; i -= 2) {
	  draw(i, (y + 11), 12);
	  SDL_Delay(delay);
	}
      }
    } else {
      if (lasty == (y - 40)) {
	for (i = y; i <= (y + 40); i += 2) {
	  draw((x + 11), i, 13);
	  SDL_Delay(delay);
	}
      } else {
	for (i = (y + 40); i >= y; i -= 2) {
	  draw((x + 11), i, 13);
	  SDL_Delay(delay);
	}
      }
    }
    // Horizontaal
    if (
	(maparray[x + 40][y] == 1 || maparray[x + 40][y] == 7
	 || maparray[x + 40][y] == 6 || maparray[x + 40][y] == 5
	 || maparray[x + 40][y] == 9) && lastx == (x - 40)) {
      //Rechts
      nexttile((x + 40), y, x, y);
      break;
    }
    if (
	(maparray[x - 40][y] == 1 || maparray[x - 40][y] == 5
	 || maparray[x - 40][y] == 4 || maparray[x - 40][y] == 3
	 || maparray[x - 40][y] == 9) && lastx == (x + 40)) {
      nexttile((x - 40), y, x, y);
      break;
      //Links
    }
    // Verticaal
    if (
	(maparray[x][y + 40] == 2 || maparray[x][y + 40] == 7
	 || maparray[x][y + 40] == 3 || maparray[x][y + 40] == 5
	 || maparray[x][y + 40] == 9) && lasty == (y - 40)) {
      //Beneden
      nexttile(x, (y + 40), x, y);
      break;
    }
    if (
	(maparray[x][y - 40] == 2 || maparray[x][y - 40] == 6
	 || maparray[x][y - 40] == 4 || maparray[x][y - 40] == 5
	 || maparray[x][y - 40] == 9) && lasty == (y + 40)) {
      //Boven
      nexttile(x, (y - 40), x, y);
      break;
    }
    overstroom(x, y);
    break;
  case 6:
    maparray[x][y] = 8;
    // Linksonder
    if (lasty == (y + 40)) {
      for (i = (y + 40); i >= (y + 26); i -= 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
      for (i = (x + 27); i >= (x + 1); i -= 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    } else {
      for (i = x; i <= (x + 27); i += 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
      for (i = (y + 11); i <= (y + 40); i += 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    }
    if (
	(maparray[x][y + 40] == 2 || maparray[x][y + 40] == 7
	 || maparray[x][y + 40] == 3 || maparray[x][y + 40] == 5
	 || maparray[x][y + 40] == 9) && lastx == (x - 40)) {
      //Vanaf onder
      nexttile(x, (y + 40), x, y);
      break;
    }
    if (
	(maparray[x - 40][y] == 1 || maparray[x - 40][y] == 5
	 || maparray[x - 40][y] == 3 || maparray[x - 40][y] == 4
	 || maparray[x - 40][y] == 9) && lasty == (y + 40)) {
      //Vanaf links
      nexttile((x - 40), y, x, y);
      break;
    }
    overstroom(x, y);
    break;
  case 7:
    maparray[x][y] = 8;
    // Linksboven
    if (lasty == (y - 40)) {
      for (i = y; i <= (y + 27); i += 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
      for (i = (x + 27); i >= (x + 1); i -= 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
    } else {
      for (i = x; i <= (x + 27); i += 2) {
	draw(i, (y + 11), 12);
	SDL_Delay(delay);
      }
      for (i = (y + 26); i >= y; i -= 2) {
	draw((x + 11), i, 13);
	SDL_Delay(delay);
      }
    }
    if (
	(maparray[x][y - 40] == 2 || maparray[x][y - 40] == 4
	 || maparray[x][y - 40] == 6 || maparray[x][y - 40] == 5
	 || maparray[x][y - 40] == 9) && lastx == (x - 40)) {
      //Vanaf boven
      nexttile(x, (y - 40), x, y);
      break;
    }
    if (
	(maparray[x - 40][y] == 1 || maparray[x - 40][y] == 4
	 || maparray[x - 40][y] == 3 || maparray[x - 40][y] == 5
	 || maparray[x - 40][y] == 9) && lasty == (y - 40)) {
      //Vanaf links
      nexttile((x - 40), y, x, y);
      break;
    }
    overstroom(x, y);
    break;
  default:
    // Als je hier bent is er iets goed mis!!
    fprintf(stderr, "BUGG!! :(\n");
    break;
  }
}

void overstroom(int x, int y)
{
  int honderd, tien, een;
  shouldwork = -1;
  draw(x, y, 14);
  draw(192, 190, 28);
  honderd = (floor(punten / 100));
  tien = floor(punten / 10);
  een = punten - (honderd * 100) - (tien * 10);
  erase(298, 235, 40, 40, 0);
  erase(313, 235, 40, 40, 0);
  erase(328, 235, 40, 40, 0);
  draw(298, 235, honderd + 15);
  draw(313, 235, tien + 15);
  draw(328, 235, een + 15);
  while (1) {
    while (SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_KEYDOWN:
	if (strcmp((SDL_GetKeyName(event.key.keysym.sym)), "space") == 0) {
	  //tc=0;
	  //mainmenu();
	  return;
	}
	break;
      case SDL_QUIT:
	exit(0);
	break;
      default:
	break;
      }
    }
  }
  return;
}

void placetile(int nr)
{
  int tmp, honderd, tien, een, oud, ready_pressed = 0, q_pressed = 0;
  if (finished == 1) {
    finished = 0;
    mainmenu();
  }
  while (shouldwork == 1) {
    if (SDL_GetTicks() >= tijd_nodig && tc == 0) {
      Dtime = 0;
      tc = 1;
      thread = SDL_CreateThread(fluid, NULL);
    }
    if (Dtime == 1) {
      tmp = floor(0.5 + ((tijd_nodig - SDL_GetTicks()) / 1000));
      honderd = (floor(tmp / 100));
      tien = floor(tmp / 10);
      een = tmp - (honderd * 100) - (tien * 10);
      if (oud != een) {
	oud = een;
	erase(5, 450, 40, 40, 0);
	erase(20, 450, 40, 40, 0);
	erase(35, 450, 40, 40, 0);
	draw(5, 450, honderd + 15);
	draw(20, 450, tien + 15);
	draw(35, 450, een + 15);
      }
    }
    while (SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_KEYDOWN:
	if ((strcmp((SDL_GetKeyName(event.key.keysym.sym)), "q") == 0)
	    && finished != -1) {
	  mainmenu();
	}
	break;
      case SDL_MOUSEMOTION:
	if (event.motion.x > 0 && event.motion.x < 60
	    && event.motion.y > 400 && event.motion.y < 425) {
	  draw(0, 400, 25);
	  ready_pressed = 1;
	} else {
	  if (ready_pressed == 1) {
	    erase(0, 400, 60, 25, 0);
	    draw(0, 400, 11);
	    ready_pressed = 0;
	  }
	}
	if (event.motion.x > 0 && event.motion.x < 60
	    && event.motion.y > 375 && event.motion.y < 400) {
	  draw(0, 375, 27);
	  q_pressed = 1;
	} else {
	  if (q_pressed == 1) {
	    erase(0, 375, 60, 25, 0);
	    draw(0, 375, 26);
	    q_pressed = 0;
	  }
	}
	break;
      case SDL_MOUSEBUTTONDOWN:
	if (event.button.x > 80 && event.button.x < 640
	    && event.button.y > 0 && event.button.y < 480) {
	  settile(sidetile[nr], 40 * (floor(event.button.x / 40)),
		  40 * (floor(event.button.y / 40)));
	  return;
	} else {
	  if (event.button.x > 0 && event.button.x < 60 &&
	      event.button.y > 400 && event.button.y < 425) {
	    Dtime = 0;
	    tc = 1;
	    thread = SDL_CreateThread(fluid, NULL);
	  }
	  if ((event.button.x > 0 && event.button.x < 60 &&
	       event.button.y > 375 && event.button.y < 400)
	      && finished != -1) {
	    mainmenu();
	  }
	}
	break;
      case SDL_QUIT:
	exit(0);
	break;
      }
    }
  }

}

/* Erase part of the screen back to the background: (Bill Kendrick) */

void erase(int x, int y, int w, int h, int bkgd)
{
  SDL_Rect dest;

  dest.x = x;
  dest.y = y;
  dest.w = w;
  dest.h = h;

  SDL_BlitSurface(images2[bkgd], &dest, screen, &dest);
  SDL_UpdateRects(screen, 1, &dest);
}


/* Draw an object: (Bill Kendrick) */

void draw(int x, int y, int pict)
{
  SDL_Rect src, dest;

  src.x = 0;
  src.y = 0;
  src.w = images[pict]->w;
  src.h = images[pict]->h;

  dest.x = x;
  dest.y = y;
  dest.w = src.w;
  dest.h = src.h;

  SDL_BlitSurface(images[pict], &src, screen, &dest);
  SDL_UpdateRects(screen, 1, &dest);
}

void draw2(int x, int y, int pict)
{
  SDL_Rect src, dest;

  src.x = 0;
  src.y = 0;
  src.w = images2[pict]->w;
  src.h = images2[pict]->h;

  dest.x = x;
  dest.y = y;
  dest.w = src.w;
  dest.h = src.h;

  SDL_BlitSurface(images2[pict], &src, screen, &dest);
  SDL_UpdateRects(screen, 1, &dest);
}

void mainmenu()
{
  int start_pressed = 0, quit_pressed = 0;
  if (sound == 1) {
    Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels);

    /* Set the external music player, if any */
    Mix_SetMusicCMD(getenv("MUSIC_CMD"));

    /* Load the requested music file */
    music = Mix_LoadMUS(DATA_PREFIX "music/main.mod");
    if (music == NULL) {
      fprintf(stderr, "Couldn't load music");
      exit(2);
    }
    Mix_FadeInMusic(music, -1, 2000);
  }
  draw2(0, 0, 2);
  draw2(268, 160, 3);
  draw2(268, 190, 5);
  while (1) {
    while (SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_KEYDOWN:
	if (strcmp((SDL_GetKeyName(event.key.keysym.sym)), "q") == 0) {
	  exit(0);
	}
	break;
      case SDL_MOUSEMOTION:
	if (event.motion.x > 268 && event.motion.x < 374
	    && event.motion.y > 160 && event.motion.y < 190) {
	  draw2(268, 160, 4);
	  start_pressed = 1;
	} else {
	  if (start_pressed == 1) {
	    draw2(268, 160, 3);
	    start_pressed = 0;
	  }
	}
	if (event.motion.x > 268 && event.motion.x < 374
	    && event.motion.y > 190 && event.motion.y < 220) {
	  draw2(268, 190, 6);
	  quit_pressed = 1;
	} else {
	  if (quit_pressed == 1) {
	    draw2(268, 190, 5);
	    quit_pressed = 0;
	  }
	}
	break;
      case SDL_MOUSEBUTTONDOWN:
	if (event.button.x > 0 && event.button.x < 640
	    && event.button.y > 190 && event.button.y < 220) {
	  exit(0);
	}
	if (event.button.x > 0 && event.button.x < 640
	    && event.button.y > 160 && event.button.y < 190) {
	  shouldwork = 1;
	  play();
	}
	break;
      case SDL_QUIT:
	exit(0);
	break;
      }
    }
  }
  return;
}

void play()
{
  int m, z;

  tc = 0;
  shouldwork = 1;
  Dtime = 1;
  /* Set sidebar */
  sideposx[0] = 8;
  sideposy[0] = 250;
  sideposx[1] = 8;
  sideposy[1] = 210;
  sideposx[2] = 8;
  sideposy[2] = 170;
  sideposx[3] = 8;
  sideposy[3] = 130;
  sideposx[4] = 8;
  sideposy[4] = 90;
  sideposx[5] = 8;
  sideposy[5] = 50;
  sideposx[6] = 8;
  sideposy[6] = 10;
  sidetile[0] = ((rand() % 7) + 1);
  sidetile[1] = ((rand() % 7) + 1);
  sidetile[2] = ((rand() % 7) + 1);
  sidetile[3] = ((rand() % 7) + 1);
  sidetile[4] = ((rand() % 7) + 1);
  sidetile[5] = ((rand() % 7) + 1);
  sidetile[6] = ((rand() % 7) + 1);


  /* Init maparray */
  for (m = 0; m <= 700; m++) {
    for (z = 0; z <= 700; z++) {
      maparray[m][z] = -1;
    }
  }
  /* Seed random generator: */

  srand(SDL_GetTicks());

  /* Start music */

  if (sound == 1) {
    Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels);

    /* Set the external music player, if any */
    Mix_SetMusicCMD(getenv("MUSIC_CMD"));

    /* Load the requested music file */
    music = Mix_LoadMUS(DATA_PREFIX "music/music.mod");
    if (music == NULL) {
      fprintf(stderr, "Couldn't load music");
      exit(2);
    }

    Mix_FadeInMusic(music, -1, 2000);
  }

  /* Build sidebar */
  //ShowBMP("sidebar.bmp", screen, 0, 0);
  draw2(0, 0, 0);
  draw2(60, 0, 1);
  draw(0, 400, 11);
  draw(0, 375, 26);

  /* Place "source" */
  xrand = 40 + (40 * floor((((rand() % 13) * 40) + 60) / 40));
  yrand = 40 * floor((rand() % 10) * 40) / 40;
  settile(0, xrand, yrand);
  maparray[xrand][yrand] = 0;
  nu = 60000;			// One minute
  tijd_nodig = SDL_GetTicks() + nu;
  delay = 20;
  while (1) {
    placetile(0);
  }
  exit(0);
}

int main(int argc, char *argv[])
{
  int i;
  SDL_Surface *image;

#ifdef __BEOS__
int counti;
char datapath[256];
for (counti=strlen(argv[0]) ; argv[0][counti]!='/' ; counti--);
strncpy(datapath, argv[0], counti);
chdir(datapath);
#endif

  // Init SDL
  if (SDL_Init(SDL_INIT_VIDEO) < 0) {
    fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }

  // Maak beeld (640x480, 16bpp)
  screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);
  if (screen == NULL) {
    fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }
  // Zet windowtitle en plaatjes
  SDL_WM_SetCaption("Pipez", "Pipez");

  /* Open the audio device */
  if (Mix_OpenAudio
      (audio_rate, audio_format, audio_channels, audio_buffers) < 0) {
    fprintf(stderr, "Couldn't open audio: %s\n", SDL_GetError());
    sound = 0;
  } else {
    sound = 1;
  }

  /* Load graphics: */

  for (i = 0; i < NUM_IMAGES; i++) {
    /* Load image file: */

    image = SDL_LoadBMP(image_names[i]);

    if (image == NULL) {
      fprintf(stderr,
	      "\nError: I couldn't load a graphics file:\n"
	      "%s\n"
	      "The Simple DirectMedia error that occured was:\n"
	      "%s\n\n", image_names[i], SDL_GetError());
      exit(1);
    }


    /* Set transparency: */

    images[i] = SDL_DisplayFormat(image);
    if (images[i] == NULL) {
      fprintf(stderr,
	      "\nError: I couldn't convert a file to the display format:\n"
	      "%s\n"
	      "The Simple DirectMedia error that occured was:\n"
	      "%s\n\n", image_names[i], SDL_GetError());
      exit(1);
    }

    if (SDL_SetColorKey(images[i], (SDL_SRCCOLORKEY),
			SDL_MapRGB(images[i]->format,
				   0xFF, 0xFF, 0xFF)) == -1) {
      fprintf(stderr,
	      "\nError: I could not set the color key for the file:\n"
	      "%s\n"
	      "The Simple DirectMedia error that occured was:\n"
	      "%s\n\n", image_names[i], SDL_GetError());
      exit(1);
    }

    SDL_FreeSurface(image);


  }

  /* Load sounds: */

  if (sound == 1) {
    for (i = 0; i < NUM_SOUNDS; i++) {
      sounds[i] = Mix_LoadWAV(sound_names[i]);
      if (sounds[i] == NULL) {
	fprintf(stderr,
		"\nError: I could not load the sound file:\n"
		"%s\n"
		"The Simple DirectMedia error that occured was:\n"
		"%s\n\n", sound_names[i], SDL_GetError());
	exit(1);
      }
    }
  }

  /* Load non-transparent graphics: */

  for (i = 0; i < NUM_IMAGES2; i++) {
    /* Load image file: */

    image = SDL_LoadBMP(image_names2[i]);

    if (image == NULL) {
      fprintf(stderr,
	      "\nError: I couldn't load a graphics file:\n"
	      "%s\n"
	      "The Simple DirectMedia error that occured was:\n"
	      "%s\n\n", image_names2[i], SDL_GetError());
      exit(1);
    }

    images2[i] = SDL_DisplayFormat(image);
    if (images2[i] == NULL) {
      fprintf(stderr,
	      "\nError: I couldn't convert a file to the display format:\n"
	      "%s\n"
	      "The Simple DirectMedia error that occured was:\n"
	      "%s\n\n", image_names2[i], SDL_GetError());
      exit(1);
    }

    SDL_FreeSurface(image);


  }


  mainmenu();



  SDL_Quit();
  return 0;
}
